package AERPP;
import java.util.Random;
import java.util.ArrayList;

public class GenerateRandomObservation {

	private double[] realP;
	private int numberOfExperiments;
	private int numberOfCasesInEachExperiment;
	private ArrayList<double[]> observedFList;
	private ArrayList<double[]> betaObservedFList;
	private Random r;
	private double eps=1e-8;
	
	public GenerateRandomObservation(double[] realP, int numberOfExperiments,int numberOfCasesInEachExperiment) {
		super();
		this.realP = realP;
		this.numberOfExperiments = numberOfExperiments;
		this.numberOfCasesInEachExperiment = numberOfCasesInEachExperiment;
		this.observedFList=new ArrayList<double[]>();
		this.betaObservedFList=new ArrayList<double[]>();
		this.r=new Random();
	}
	
	public void generateObservationList(){
		
		double[] cumulativeRealP=new double[realP.length];
		cumulativeRealP[0]=realP[0];
		for (int k=1;k<realP.length;k++){
			cumulativeRealP[k]=cumulativeRealP[k-1]+realP[k];
		}
		for (int i=0;i<numberOfExperiments;i++){
			double[] observedF=new double[realP.length];
			double[] betaOF=new double[realP.length];
			int[] appreanceTime=new int[realP.length];
			for(int j=0;j<numberOfCasesInEachExperiment;j++){
				double rN=r.nextDouble();
				for (int k=0;k<realP.length;k++){
					if (cumulativeRealP[k]>rN-eps){
						appreanceTime[k]++;
						break;
					}
				}			
			}
			//System.out.print("ob "+i+":    ");
			for (int k=0;k<realP.length;k++){
				observedF[k]=(double)(appreanceTime[k])/(double)(numberOfCasesInEachExperiment);
			//	System.out.print(observedF[k]+",");
			}
			//System.out.println("");
			observedFList.add(observedF);
			double[] gama=new double[realP.length];
			double s=0;
			for (int j=0;j<realP.length;j++){
				boolean pp=r.nextBoolean();			
			//	gama[j]=r.nextDouble();
				gama[j]=1;
				if (pp==true){
					gama[j]=-1*gama[j];
				}
				s+=gama[j];
			}
			for (int j=0;j<realP.length;j++){
				gama[j]=(gama[j]-s/realP.length)/(1+Math.abs(s)/realP.length);
				betaOF[j]=observedF[j]+gama[j]/Math.sqrt(numberOfCasesInEachExperiment);
			}
			betaObservedFList.add(betaOF);
		}
	}

	public ArrayList<double[]> getObservedFList() {
		return observedFList;
	}

	public ArrayList<double[]> getBetaObservedFList() {
		return betaObservedFList;
	}
	
	
		
}
