package AERPP;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;

public class SmartSelectionEQ {

	private double[] realP;
	private int[][] networkIndicator;
	private int[][] networkIndicatorInverse;
	private double[] realPInverse;
	private int noOfCause;
	private int noOfOb;
	private ArrayList<int[]> AEntire;
	private ArrayList<Double> cEntire;
	private ArrayList<int[]> AP;
	private ArrayList<Double> cP;
	private ArrayList<int[]> BInverse;
	private ArrayList<int[]> ANGreater;
	private ArrayList<int[]> ANLess;
	private ArrayList<int[]> AEq;
	private ArrayList<Double> cEq;
	private long runningTime;
	private HashSet<Integer> hAP;
	private HashSet<Integer> hANLess;
	private boolean connection;

	public SmartSelectionEQ(double[] realP, int[][] networkIndicator) {
		super();
		this.realP = realP;
		this.networkIndicator = networkIndicator;
		this.noOfCause=networkIndicator.length;
		this.noOfOb=realP.length;
		this.networkIndicatorInverse=new int[noOfOb][noOfCause];
		for (int i=0;i<noOfCause;i++){
			for (int j=0;j<noOfOb;j++){
				networkIndicatorInverse[j][i]=networkIndicator[i][j];
			}
		}
		this.realPInverse=new double[noOfCause];
		for (int i=0;i<noOfCause;i++){
			realPInverse[i]=(1.0)/(double)(noOfCause);
		}
		this.AEq=new ArrayList<int[]>();
		this.cEq=new ArrayList<Double>();
		this.ANGreater=new ArrayList<int[]>();
		this.ANLess=new ArrayList<int[]>();
		this.hAP=new HashSet<Integer>();
		this.hANLess=new HashSet<Integer>();

	}

	public void getEntire(){
		
	}
	
	
	public void selection(){
		long timeStart=System.currentTimeMillis();
		checkConnection();

		// Get AP
		SmartSelectionINEQ smsP=new SmartSelectionINEQ(realP,networkIndicator);
		smsP.selection();		
		AP=smsP.getASmart();
		cP=smsP.getcSmart();
		System.out.println("Su");
		for (int i=0;i<AP.size();i++){
			System.out.println();
			for (int j=0;j<AP.get(0).length;j++){
				System.out.print(AP.get(i)[j]+",");
			}
		}
		
		System.out.println("Size:"+AP.size());
		
		// Get B
		SmartSelectionINEQ smsInverse=new SmartSelectionINEQ(realPInverse,networkIndicatorInverse);
		smsInverse.selection();		
		BInverse=smsInverse.getASmart();


		System.out.println("Size inverse:"+BInverse.size());

		
		// Get ANGreater and ANLess corresponding to B
		for (int i=0;i<BInverse.size();i++){
			int[] biInverse=BInverse.get(i);
			int[] ai=new int[noOfCause];
			for (int j=0;j<noOfCause;j++){
				for (int k=0;k<noOfOb;k++){
					if (biInverse[k]==1&&networkIndicatorInverse[k][j]==1){
						ai[j]=1;
						break;
					}
				}
			}
			ANGreater.add(ai);
			int[] aiLess=new int[noOfCause];
			for (int j=0;j<noOfCause;j++){
				if (ai[j]==1){
					aiLess[j]=0;
				}
				else{
					aiLess[j]=1;
				}
			}
			ANLess.add(aiLess);
		}
		
		System.out.println("ANLess");

		for (int i=0;i<ANLess.size();i++){
			System.out.println();
			for (int j=0;j<ANLess.get(0).length;j++){
				System.out.print(ANLess.get(i)[j]+",");
			}
		}

		// generate Hash table for AP
		for (int[] ap:AP){
			Integer[] apI=new Integer[noOfCause];
			for (int i=0;i<noOfCause;i++){
				apI[i]=ap[i];
			}
			hAP.add(Arrays.deepHashCode(apI)); 
		}
		
		// generate Hash table for ANLess
		for (int[] anLess:ANLess){
			Integer[] anI=new Integer[noOfCause];
			for (int i=0;i<noOfCause;i++){
				anI[i]=anLess[i];
			}
			hANLess.add(Arrays.deepHashCode(anI)); 
		}

		// choose the one in both AP and ANLess	
		for (int i=0;i<AP.size();i++){
			int[] ap=AP.get(i);
			Integer[] apI=new Integer[noOfCause];
			for (int j=0;j<noOfCause;j++){
				apI[j]=ap[j];
			}
			if (hANLess.contains(Arrays.deepHashCode(apI))){
				AEq.add(ap);
				cEq.add(cP.get(i));
			}
		}

		Integer[] allI=new Integer[noOfCause];
		int[] all=new int[noOfCause];
		for (int i=0;i<noOfCause;i++){
			allI[i]=1;
			all[i]=1;
		}
		if (hAP.contains(Arrays.deepHashCode(allI))){
			AEq.add(all);
			cEq.add((double)(1));
		}
		//System.out.println("AInvrese:"+AInverse.size());
		runningTime=(System.currentTimeMillis()-timeStart)/1000;
		//System.out.println("--------------------------------------------------");
		System.out.println("Number of necessary inequalities:"+AEq.size());
	}


	public ArrayList<int[]> getAEq() {
		return AEq;
	}


	public ArrayList<Double> getcEq() {
		return cEq;
	}


	public long getRunningTime() {
		return runningTime;
	}

	public void printAC(){
		System.out.println("Smart Method EQ: "+AEq.size()+" inequalities:");
		for (int[] ai:AEq){
			for (int i=0;i<noOfCause;i++){
				System.out.print(ai[i]+",");
			}
			System.out.println();
		}
	}

	public void printAP(){
		System.out.println("AP:");
		for (int i=0;i<AP.size();i++){
			for (int j=0;j<noOfCause;j++){
				System.out.print(AP.get(i)[j]+",");
			}
			System.out.println();
		}
	}

	public void printAInverse(){
		System.out.println("AInverse:");
		for (int i=0;i<BInverse.size();i++){
			for (int j=0;j<noOfCause;j++){
				System.out.print(BInverse.get(i)[j]+",");
			}
			System.out.println();
		}
	}

	public void printANGreater(){
		System.out.println("AN Greater:");
		for (int i=0;i<ANGreater.size();i++){
			for (int j=0;j<noOfCause;j++){
				System.out.print(ANGreater.get(i)[j]+",");
			}
			System.out.println();
		}
	}

	public void printANLess(){
		System.out.println("AN:");
		for (int i=0;i<ANLess.size();i++){
			for (int j=0;j<noOfCause;j++){
				System.out.print(ANLess.get(i)[j]+",");
			}
			System.out.println();
		}
	}

	public void checkConnection(){
		ArrayList<Integer> connectSet=new ArrayList<Integer>();
		ArrayList<Integer> notConnectSet=new ArrayList<Integer>();
		connectSet.add(0);
		for (int i=1;i<noOfCause;i++){
			notConnectSet.add(i);
		}
		boolean stop=false;
		do {		
			boolean find=false;
			for (int i=0;i<notConnectSet.size();i++){
				int notC=notConnectSet.get(i);
				for (Integer co:connectSet){
					for (int k=0;k<noOfOb;k++){
						if (networkIndicator[notC][k]==1&&networkIndicator[co][k]==1){
							connectSet.add(notC);
							notConnectSet.remove(i);
							find=true;
							break;
						}
					}
					if (find==true){
						break;
					}
				}
				if (find==true){
					break;
				}
			}		
			if (find==false){
				stop=true;
			}
		}while (stop==false);

		if (connectSet.size()==noOfCause){
			connection=true;
		}
		else{
			connection=false;
			System.out.println("The network is not connected!");
			System.exit(0);
		}	
	}

	public boolean isConnection() {
		return connection;
	}

	public ArrayList<int[]> getAEntire() {
		return AEntire;
	}

	public ArrayList<Double> getcEntire() {
		return cEntire;
	}



}
