package AERPP;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;

public class SmartSelectionINEQ {

	private double[] realP;
	private int[][] networkIndicator;
	private ArrayList<int[]> ASmart;
	private ArrayList<Double> cSmart;
	private int noOfCause;
	private int noOfOb;
	private final double eps=1e-8;
	private int[][] neighbor;
	private long runningTime;
	private HashSet<Integer> h; 


	public SmartSelectionINEQ(double[] realP, int[][] networkIndicator){
		this.realP=realP;
		this.networkIndicator=networkIndicator;
		this.ASmart=new ArrayList<int[]>();
		this.cSmart=new ArrayList<Double>();
		this.noOfCause=networkIndicator.length;
		this.noOfOb=realP.length;
		this.neighbor=new int[noOfCause][noOfCause];
		for (int i=0;i<noOfCause;i++){
			for (int j=0;j<noOfCause;j++){
				for (int k=0;k<noOfOb;k++){
					if (networkIndicator[i][k]==1&&networkIndicator[j][k]==1){
						neighbor[i][j]=1;
						break;
					}
				}
			}
		}
		runningTime=0;
		this.h=new HashSet<Integer>();
	}


	public void selection(){
		
		long timeStart=System.currentTimeMillis();
		double maxCReach=0;
		ArrayList<ArrayList<LinkedCause>> LinkedCauseList=new ArrayList<ArrayList<LinkedCause>>();
		for (int i=0;i<noOfCause;i++){
			ArrayList<LinkedCause> linkedList=new ArrayList<LinkedCause>();
			LinkedCauseList.add(linkedList);
		}

		// start with linkeCause with 1 element
		ArrayList<LinkedCause> linked1List=LinkedCauseList.get(0);
		for (int i=0;i<noOfCause;i++){
			ArrayList<Integer> coverCause=new ArrayList<Integer>();
			coverCause.add(i);
			double c=0;
			ArrayList<Integer> coverOb=new ArrayList<Integer>();
			for (int k=0;k<noOfOb;k++){
				if (networkIndicator[i][k]==1){
					c+=realP[k];
					coverOb.add(k);
				}
			}
			int[] connectionToRest=new int[noOfCause];
			for (int j=0;j<noOfCause;j++){
				connectionToRest[j]=neighbor[i][j];
			}
			Integer[] checkeCover=new Integer[noOfCause];
			checkeCover[i]=1;
			for (int j=0;j<noOfCause;j++){
				if (i!=j){
					boolean cover=true;
					for (int k=0;k<noOfOb;k++){
						if (networkIndicator[i][k]<networkIndicator[j][k]){
							cover=false;
							break;
						}
					}
					if (cover==true){
						coverCause.add(j);
						checkeCover[j]=1;
					}
				}
			}
			LinkedCause lc=new LinkedCause(noOfCause,noOfOb,coverCause,c,coverOb,connectionToRest);
			if (h.contains(Arrays.deepHashCode(checkeCover))){
			}
			else{
				h.add(Arrays.deepHashCode(checkeCover)); 
				linked1List.add(lc);
			}
		}
		
		// for linkCause with 2 to noOfCause-1 elements
		int noOfCauseInLinkedCause=2;
		do {
			//System.out.println("noOfCauseInLinkedCause:"+noOfCauseInLinkedCause);
			ArrayList<LinkedCause> previousLinkedCauseList=LinkedCauseList.get(noOfCauseInLinkedCause-2);		
			for (int i=0;i<previousLinkedCauseList.size();i++){		
				LinkedCause lc=previousLinkedCauseList.get(i);	
				//System.out.println("previousLinkedCauseList:"+lc.getCoverCause());
				if (lc.getCoverOb().size()<noOfOb){
					ArrayList<Integer> coverCausePrevious=lc.getCoverCause();
					double cPrevious=lc.getC();
					ArrayList<Integer> coverObPrevious=lc.getCoverOb();
					int[] connectionToRestPrevious=lc.getConnectionToRest();
					ArrayList<Integer> potentialExpand=lc.getPotentialExpand();
					//System.out.println("potentialExpand="+potentialExpand);
					//System.out.println("connectionToRest:"+connectionToRestPrevious[1]);
					for (Integer expCause:potentialExpand){
						int[] idCheck=new int[noOfCause];
						for (int ii=0;ii<noOfCause;ii++){
							idCheck[ii]=lc.getCoverCauseIndicator()[ii];
						}
						idCheck[expCause]=1;
						Integer[] checkeCover1=new Integer[noOfCause];
						for (int ii=0;ii<noOfCause;ii++){
							checkeCover1[ii]=idCheck[ii];
						}
						ArrayList<Integer> nextCoverCause=new ArrayList<Integer>();
						ArrayList<Integer> nextCoverOb=new ArrayList<Integer>();
						for (Integer cause: coverCausePrevious){
							nextCoverCause.add(cause);
						}
						nextCoverCause.add(expCause);	
						for (Integer ob:coverObPrevious){
							nextCoverOb.add(ob);
						}							
						double nextC=cPrevious;								
						for (int k=0;k<noOfOb;k++){
							boolean already=false;
							for (Integer cover:coverObPrevious){
								if (k==cover){
									already=true;
									break;
								}
							}
							if (already==false&&networkIndicator[expCause][k]==1){
								nextCoverOb.add(k);
								nextC+=realP[k];
							}						
						}
						ArrayList<Integer> nextNotCoverOb=new ArrayList<Integer>();
						for (int k=0;k<noOfOb;k++){
							if (nextCoverOb.contains(k)==false){
								nextNotCoverOb.add(k);
							}
						}
						int[] connectionToRest=new int[noOfCause];
						for (int countJ=0;countJ<noOfCause;countJ++){
							connectionToRest[countJ]=connectionToRestPrevious[countJ]+neighbor[expCause][countJ];
						}
						boolean findAdd=false;					
						do{				
							findAdd=false;
							for (Integer ncc:nextCoverCause){
								for (int ii=0;ii<noOfCause;ii++){
									if (nextCoverCause.contains(ii)==false&&neighbor[ncc][ii]==1){
										boolean cover=true;
										for (Integer nob:nextNotCoverOb){
											if (networkIndicator[ii][nob]==1){
												cover=false;
												break;
											}
										}
										if (cover==true){
											nextCoverCause.add(ii);
											checkeCover1[ii]=1;
											for (int countJ=0;countJ<noOfCause;countJ++){
												connectionToRest[countJ]=connectionToRest[countJ]+neighbor[ii][countJ];
											}
											findAdd=true;
											break;										
										}
									}
								}
								if (findAdd==true){
									break;
								}
							}
						}while(findAdd==true);
						if (h.contains(Arrays.deepHashCode(checkeCover1))){
						}
						else{
							maxCReach=Math.max(maxCReach, nextC);		
							if (nextC<1-eps){
								h.add(Arrays.deepHashCode(checkeCover1)); 
								LinkedCause sl=new LinkedCause(noOfCause,noOfOb,nextCoverCause,nextC,nextCoverOb,connectionToRest);
								int length=nextCoverCause.size();
								LinkedCauseList.get(length-1).add(sl);
							}
						}
					}
				}
			}
			noOfCauseInLinkedCause++;
			for (int i=0;i<LinkedCauseList.size();i++){
			//	System.out.print(LinkedCauseList.get(i).size()+",");
			}
			//System.out.println();
		} while(noOfCauseInLinkedCause<=noOfCause);

		for (ArrayList<LinkedCause> seqList:LinkedCauseList){
			for (LinkedCause lc:seqList){
				Integer[] check=new Integer[noOfCause];
				for (int ii=0;ii<noOfCause;ii++){
					check[ii]=lc.getCoverCauseIndicator()[ii];
				}
				if (h.contains(Arrays.deepHashCode(check))){
					double c=lc.getC();
					int[] ai=lc.getAi();
					ASmart.add(ai);
					cSmart.add(c);
				}
			}	
		}
		if (maxCReach>1-eps){
			int[] all=new int[noOfCause];
			Integer[] idAll=new Integer[noOfCause];
			for (int i=0;i<noOfCause;i++){
				idAll[i]=1;
				all[i]=1;
			}
			h.add(Arrays.deepHashCode(idAll)); 
			ASmart.add(all);
			cSmart.add((double)1);
		}
		//System.out.println("Selected Smart Selection INEQ:");
		//int totNoExp=(int) Math.pow(2, noOfCause);
		//System.out.println("Equavalent n="+Math.log(ASmart.size())/Math.log(2)+", Reduced n="+(noOfCause-Math.log(ASmart.size())/Math.log(2)));
		//System.out.println("Number of Constraint from Smart method:"+ASmart.size()+"/"+totNoExp);
		runningTime=(System.currentTimeMillis()-timeStart)/1000;

	}


	public ArrayList<int[]> getASmart() {
		return ASmart;
	}


	public ArrayList<Double> getcSmart() {
		return cSmart;
	}

	public long getRunningTime() {
		return runningTime;
	}

	public void printAC(){
		System.out.println("Smart Method INEQ: "+ASmart.size()+" inequalities:");
		for (int[] ai:ASmart){
			for (int i=0;i<noOfCause;i++){
				System.out.print(ai[i]+",");
			}
			System.out.println();
		}
	}

}
